\begin{algorithm}
\caption{Additional procedures \label{algo5}}
\begin{algorithmic}[1]
  \Function{GetTradingWindow}{}
    \State $start \gets \Call{max}{0,|ids| - sm - tm}$
    \State $end \gets \Call{max}{0, |ids|  - sm}$
    \State \Return $ids[start:end]$
  \EndFunction
  \item[]

  \Function{SendToNeighbourgs}{$h, ttl$}
    \State $T_p \gets \Call{GetTradingWindow}$
    \For{$k$ times}
      \State $p \gets \Call{Recode}{h, rcv} $
	\State $\Call{Send}{\textsc{Push}, ttl, T_p, p}$
    \EndFor
  \EndFunction
  \item[]

  \Function{Broadcast}{$m$}
    \State $id \gets \Call{UniqueID}$
    \State $p\gets \langle g, \{ \langle id, 1 \rangle \}, m \rangle$
    \State $rcv \gets rcv \cup \{ p \}$
    \State $ids \gets ids \cup \{ \langle g, id \rangle \}$
    \State $dlv \gets dlv \cup \{ \langle g, id \rangle \}$
    \State $\Call{SendToNeighbourgs}{g, ittl}$
    \State $\Call{NextGen}{g}$
  \EndFunction
  \item[]

\end{algorithmic}
\end{algorithm}
